local options = {
    type = 'group',
    args = {
        show = {
            type = 'execute',
            name = 'Show Dialog',
            desc = 'Show the Dialog',
            func = 'ShowDialog'
        }
    }
}
-- units
-- healer["raid3"] = "MT2"
-- Werte: Rest, MT1, MT2, MT3, MT4, MT5, Dispellen
local healer = {
}

local einteilung = {
    Rest = {},
    MT1 = {},
    MT2 = {},
    MT3 = {},
    MT4 = {},
    MT5 = {},
    Dispellen = {},
}
local stats = {
    DRUID = 0,
    PRIEST = 0,
    PALADIN = 0,
    SHAMAN = 0,
}

local L = AceLibrary("AceLocale-2.1"):GetInstance("HealOrganizer", true)

HealOrganizer = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceDebug-2.0", "AceDB-2.0")
HealOrganizer:RegisterChatCommand({"/healorganizer", "/hlorg"}, options)
HealOrganizer:RegisterDB("HealOrganizerDB", "HealOrganizerDBPerChar")
HealOrganizer:RegisterDefaults('char', {
    chan = "",
})

function HealOrganizer:OnInitialize() -- {{{
    -- Called when the addon is loaded
    --self:SetDebugging(true)
    self:Debug("starte locale")
    -- dialog labels aus locale einstellen {{{
    
    HealOrganizerDialogEinteilungTitle:SetText(L["ARRANGEMENT"])
    --
    HealOrganizerDialogEinteilungHealerpoolLabel:SetText(L["REMAINS"])
    for i=1, 20 do
        getglobal("HealOrganizerDialogEinteilungHealerpoolSlot"..i.."Label"):SetText(L["FREE"])
    end
    for j=1, 5 do
        for i=1, 3 do
            getglobal("HealOrganizerDialogEinteilungHealGroupMainTarget"..j.."Label"):SetText(L["MT"]..j)
            getglobal("HealOrganizerDialogEinteilungHealGroupMainTarget"..j.."Slot"..i.."Label"):SetText(L["FREE"])
        end
    end
    for i=1, 3 do
        getglobal("HealOrganizerDialogEinteilungHealGroupDispellSlot"..i.."Label"):SetText(L["FREE"])
    end
    HealOrganizerDialogEinteilungHealGroupDispellLabel:SetText(L["DISPEL"])
    HealOrganizerDialogEinteilungOptionenTitle:SetText(L["OPTIONS"])
    HealOrganizerDialogEinteilungOptionenDecurseText:SetText(L["DECURSE"])
    HealOrganizerDialogEinteilungOptionenHealText:SetText(L["HEAL"])
    HealOrganizerDialogEinteilungStatsTitle:SetText(L["STATS"])
    HealOrganizerDialogEinteilungStatsPriests:SetText(L["PRIESTS"]..": "..5)
    HealOrganizerDialogEinteilungStatsPriests:SetTextColor(RAID_CLASS_COLORS["PRIEST"].r,
                                                           RAID_CLASS_COLORS["PRIEST"].g,
                                                           RAID_CLASS_COLORS["PRIEST"].b)
    HealOrganizerDialogEinteilungStatsDruids:SetText(L["DRUIDS"]..": "..6)
    HealOrganizerDialogEinteilungStatsDruids:SetTextColor(RAID_CLASS_COLORS["DRUID"].r,
                                                          RAID_CLASS_COLORS["DRUID"].g,
                                                          RAID_CLASS_COLORS["DRUID"].b)
    self:Debug(UnitFactionGroup("player"))
    local faction = UnitFactionGroup("player")
    if faction == "Alliance" then
        HealOrganizerDialogEinteilungStatsHybrids:SetText(L["PALADINS"]..": "..5)
        HealOrganizerDialogEinteilungStatsHybrids:SetTextColor(RAID_CLASS_COLORS["PALADIN"].r,
                                                               RAID_CLASS_COLORS["PALADIN"].g,
                                                               RAID_CLASS_COLORS["PALADIN"].b)
    else
        HealOrganizerDialogEinteilungStatsHybrids:SetText(L["SHAMANS"]..": "..5)
        HealOrganizerDialogEinteilungStatsHybrids:SetTextColor(RAID_CLASS_COLORS["SHAMAN"].r,
                                                               RAID_CLASS_COLORS["SHAMAN"].g,
                                                               RAID_CLASS_COLORS["SHAMAN"].b)
    end
    HealOrganizerDialogBroadcastTitle:SetText(L["BROADCAST"])
    HealOrganizerDialogBroadcastChannel:SetText(L["CHANNEL"])
    HealOrganizerDialogBroadcastRaid:SetText(L["RAID"])
    HealOrganizerDialogClose:SetText(L["CLOSE"])
    HealOrganizerDialogReset:SetText(L["RESET"])
    -- }}}
    self:Debug("locale zuende")
    self:Debug("channel aus der DB ist gesetzt auf: \""..self.db.char.chan.."\"")
    self:UpdateDialogValues()
end -- }}}

function HealOrganizer:OnEnable() -- {{{
    -- Called when the addon is enabled
end -- }}}

function HealOrganizer:OnDisable() -- {{{
    -- Called when the addon is disabled
end -- }}}

function HealOrganizer:RefreshTables() --{{{
    self:Debug("aktuallisiere tabellen")
    stats = {
        DRUID = 0,
        PRIEST = 0,
        PALADIN = 0,
        SHAMAN = 0,
    }
    local gruppen = {
        MT1 = 0,
        MT2 = 0,
        MT3 = 0,
        MT4 = 0,
        MT5 = 0,
        Dispellen = 0
    }
    -- heiler suchen
    for i=1, MAX_RAID_MEMBERS do
        if not UnitExists("raid"..i) then
            -- kein mitglied, also auch kein heiler
            healer["raid"..i] = nil
        else
            -- prfen ob er ein heiler ist
            local class,engClass = UnitClass("raid"..i)
            if engClass == "DRUID" or engClass == "PRIEST" or
                    engClass == "PALADIN" or engClass == "SHAMAN" then
                -- ist ein heiler, aber schon eingeteilt?
                if healer["raid"..i] then
                    -- schon eingeteilt, nichts machen
                    if healer["raid"..i] ~= "Rest" then
                        if gruppen[healer["raid"..i]] >= 3 then
                            -- schon zu viele, mach ihm zum rest
                            healer["raid"..i] = "Rest"
                        end
                    end
                else
                    -- nicht eingeteilt, neu, "rest"
                    healer["raid"..i] = "Rest"  
                end
                stats[engClass] = stats[engClass] + 1                
            else
            -- ist kein heiler, nil
            healer["raid"..i] = nil
            end
        end
    end
    self:Debug("stats generiert")
    self:Debug("healertabelle aktuallisiert")
    -- healer[...] -> einteilungsarray
    einteilung = {
        Rest = {},
        MT1 = {},
        MT2 = {},
        MT3 = {},
        MT4 = {},
        MT5 = {},
        Dispellen = {},
    }
    for unit, ort in pairs(healer) do
        table.insert(einteilung[ort], unit)    
    end
    self:Debug("einteilungstabelle aktuallisiert")
    -- einteilungstabelle sortieren (Klasse, Name)
    local function SortEinteilung(a, b) --{{{
        --[[
        -- Priester,
        -- Druiden,
        -- Paladine,
        -- Schamanen,
        --    NameA,
        --    NameZ
        --]]
        local classA, engClassA = UnitClass(a)
        local classB, engClassB = UnitClass(b)
        if engClassA ~= engClassB then
            -- unterscheidung an der Klasse
            -- ecken abfangen
            if engClassA == "PRIEST" then -- (Priest, *)
                return true
            end
            if engClassB == "PRIEST" then -- (*, Priest)
                return false
            end
            if engClassB == "SHAMAN" then -- (*, Shaman)
                return true
            end
            if engClassA == "SHAMAN" then -- (Shaman, *)
                return false
            end
            -- inneren zwei
            if engClassA == "DRUID" then -- (Druid, *)
                return true
            end
            if engClassB == "DRUID" then -- (*, Druid)
                return false
            end
            if engClassB == "PALADIN" then -- (*, Paladin)
                return true
            end
            if engClassA == "PALADIN" then -- (Paladin, *)
                return false
            end
        else
            -- klassen sind gleich, nach namen sortieren
            local nameA = UnitName(a)
            local nameB = UnitName(b)
            return a<b
        end
        return true
    end --}}}
    table.sort(einteilung.Rest, SortEinteilung)
    table.sort(einteilung.MT1, SortEinteilung)
    table.sort(einteilung.MT2, SortEinteilung)
    table.sort(einteilung.MT3, SortEinteilung)
    table.sort(einteilung.MT4, SortEinteilung)
    table.sort(einteilung.MT5, SortEinteilung)
    table.sort(einteilung.Dispellen, SortEinteilung)
    assert(table.getn(einteilung.Rest) < 21)
    assert(table.getn(einteilung.MT1) < 4)
    assert(table.getn(einteilung.MT2) < 4)
    assert(table.getn(einteilung.MT3) < 4)
    assert(table.getn(einteilung.MT4) < 4)
    assert(table.getn(einteilung.Dispellen) < 4)
end -- }}}

function HealOrganizer:ShowDialog() -- {{{
    self:UpdateDialogValues()
    self:Debug("Zeige dialog")
    HealOrganizerDialog:Show()
end -- }}}

function HealOrganizer:UpdateDialogValues() -- {{{
    self:RefreshTables()
    -- stats aktuallisieren {{{
    HealOrganizerDialogEinteilungStatsPriests:SetText(L["PRIESTS"]..": "..stats["PRIEST"])
    HealOrganizerDialogEinteilungStatsPriests:SetTextColor(RAID_CLASS_COLORS["PRIEST"].r,
                                                           RAID_CLASS_COLORS["PRIEST"].g,
                                                           RAID_CLASS_COLORS["PRIEST"].b)
    HealOrganizerDialogEinteilungStatsDruids:SetText(L["DRUIDS"]..": "..stats["DRUID"])
    HealOrganizerDialogEinteilungStatsDruids:SetTextColor(RAID_CLASS_COLORS["DRUID"].r,
                                                          RAID_CLASS_COLORS["DRUID"].g,
                                                          RAID_CLASS_COLORS["DRUID"].b)
    self:Debug(UnitFactionGroup("player"))
    local faction = UnitFactionGroup("player")
    if faction == "Alliance" then
        HealOrganizerDialogEinteilungStatsHybrids:SetText(L["PALADINS"]..": "..stats["PALADIN"])
        HealOrganizerDialogEinteilungStatsHybrids:SetTextColor(RAID_CLASS_COLORS["PALADIN"].r,
                                                               RAID_CLASS_COLORS["PALADIN"].g,
                                                               RAID_CLASS_COLORS["PALADIN"].b)
    else
        HealOrganizerDialogEinteilungStatsHybrids:SetText(L["SHAMANS"]..": "..stats["SHAMAN"])
        HealOrganizerDialogEinteilungStatsHybrids:SetTextColor(RAID_CLASS_COLORS["SHAMAN"].r,
                                                               RAID_CLASS_COLORS["SHAMAN"].g,
                                                               RAID_CLASS_COLORS["SHAMAN"].b)
    end
    -- }}}
    HealOrganizerDialogBroadcastChannelEditbox:SetText(self.db.char.chan)
    -- einteilungen aktuallisieren -- {{{
    -- alle buttons verstecken
    for i=1, 20 do
        getglobal("HealOrganizerDialogButton"..i):ClearAllPoints()
        getglobal("HealOrganizerDialogButton"..i):Hide()
    end
    self:Debug("Rest: "..table.concat(einteilung.Rest,", "))
    self:Debug("MT1: "..table.concat(einteilung.MT1, ", "))
    self:Debug("MT2: "..table.concat(einteilung.MT2, ", "))
    self:Debug("MT3: "..table.concat(einteilung.MT3, ", "))
    self:Debug("MT4: "..table.concat(einteilung.MT4, ", "))
    self:Debug("MT5: "..table.concat(einteilung.MT5, ", "))
    self:Debug("Dispell: "..table.concat(einteilung.Dispellen, ", "))
    local zaehler = 1
    -- Rest {{{
    for i=1, table.getn(einteilung.Rest) do
        -- max 20 durchlufe
        if zaehler > 20 then
            -- zu viel, abbrechen
            break
        end
        local button = getglobal("HealOrganizerDialogButton"..zaehler)
        local buttonlabel = getglobal(button:GetName().."Label")
        local buttoncolor = getglobal(button:GetName().."Color")
        -- habe den Button an sich, das Label und die Farbe, einstellen
        buttonlabel:SetText(UnitName(einteilung.Rest[i]))
        local class, engClass = UnitClass(einteilung.Rest[i])
        local color = RAID_CLASS_COLORS[engClass];
        if color then
            buttoncolor:SetTexture(color.r, color.g, color.b)
        end
        -- ancher und position einstellen
        button:SetPoint("TOP", "HealOrganizerDialogEinteilungHealerpoolSlot"..i)
        button:Show()
        -- RaidID im button speichern
        button.raidID = einteilung.Rest[i]
        zaehler = zaehler + 1
    end
    -- }}}
    -- MTs {{{
    for j=1,5 do
        for i=1, table.getn(einteilung["MT"..j]) do
            assert(i<4)
            -- max 20 durchlufe
            if zaehler > 20 then
                -- zu viel, abbrechen
                break
            end
            local button = getglobal("HealOrganizerDialogButton"..zaehler)
            local buttonlabel = getglobal(button:GetName().."Label")
            local buttoncolor = getglobal(button:GetName().."Color")
            -- habe den Button an sich, das Label und die Farbe, einstellen
            buttonlabel:SetText(UnitName(einteilung["MT"..j][i]))
            local class, engClass = UnitClass(einteilung["MT"..j][i])
            local color = RAID_CLASS_COLORS[engClass];
            if color then
                buttoncolor:SetTexture(color.r, color.g, color.b)
            end
            -- ancher und position einstellen
            button:SetPoint("TOP", "HealOrganizerDialogEinteilungHealGroupMainTarget"..j.."Slot"..i)
            button:Show()
            -- RaidID im button speichern
            button.raidID = einteilung["MT"..j][i]
            zaehler = zaehler + 1
        end
    end
    -- }}}
    -- dispellen {{{
    for i=1, table.getn(einteilung.Dispellen) do
        assert(i<4)
        -- max 20 durchlufe
        if zaehler > 20 then
            -- zu viel, abbrechen
            break
        end
        local button = getglobal("HealOrganizerDialogButton"..zaehler)
        local buttonlabel = getglobal(button:GetName().."Label")
        local buttoncolor = getglobal(button:GetName().."Color")
        -- habe den Button an sich, das Label und die Farbe, einstellen
        buttonlabel:SetText(UnitName(einteilung.Dispellen[i]))
        local class, engClass = UnitClass(einteilung.Dispellen[i])
        local color = RAID_CLASS_COLORS[engClass];
        if color then
            buttoncolor:SetTexture(color.r, color.g, color.b)
        end
        -- ancher und position einstellen
        button:SetPoint("TOP", "HealOrganizerDialogEinteilungHealGroupDispellSlot"..i)
        button:Show()
        -- RaidID im button speichern
        button.raidID = einteilung.Dispellen[i]
        zaehler = zaehler + 1
    end
    -- }}}
    -- }}}
end -- }}}

function HealOrganizer:HideDialog() -- {{{
    self:Debug("schliee dialog")
    -- TODO: chan in DB speichern
    HealOrganizerDialog:Hide()
end -- }}}

function HealOrganizer:ResetData() -- {{{
    -- einfach alle heiler lschen und neu bauen
    self:Debug("einteilung resetten") 
    healer = {}
    self:UpdateDialogValues()
end -- }}}

function HealOrganizer:BroadcastChan() --{{{
    self:Debug("broadcast to chan")
    -- bin ich im chan?
    if GetNumRaidMembers() == 0 then
        self:CustomPrint(1, 0.2, 0.2, self.printFrame, nil, " ", L["NOT_IN_RAID"])
        return;
    end
    local id, name = GetChannelName(self.db.char.chan)
    if id == 0 then
        -- nein, nicht drin
        self:Print(L["NO_CHANNEL"], self.db.char.chan)
        return;
    end
    local messages = self:BuildMessages()
    self:Debug("sende nachrichten in den chan "..self.db.char.chan)
    for _, message in pairs(messages) do
        SendChatMessage(message, "CHANNEL", nil, id)
    end
end -- }}}

function HealOrganizer:BroadcastRaid() -- {{{
    self:Debug("broadcast to raid")
    if GetNumRaidMembers() == 0 then
        self:CustomPrint(1, 0.2, 0.2, self.printFrame, nil, " ", L["NOT_IN_RAID"])
        return;
    end
    local messages = self:BuildMessages()
    for _, message in pairs(messages) do
        SendChatMessage(message, "RAID")
    end
end -- }}}

function HealOrganizer:BuildMessages() -- {{{
    local messages = {}
    table.insert(messages, L["HEALARRANGEMENT"]..":")
    -- MT1-MT5, dispell, rest
    -- {{{ MTs
    for i=1,5 do
        if getn(einteilung["MT"..i]) ~= 0 then
            local names={}
            for _, unit in pairs(einteilung["MT"..i]) do
                if UnitExists(unit) then
                    name = UnitName(unit)
                    table.insert(names, name)
                end
            end
            table.insert(messages, L["MT"]..i..": "..table.concat(names, ","))
        end
    end
    -- }}}
    -- {{{ dispellen
    if getn(einteilung.Dispellen) ~= 0 then
        local names={}
        for _, unit in pairs(einteilung.Dispellen) do
            if UnitExists(unit) then
                name = UnitName(unit)
                table.insert(names, name)
            end
        end
        table.insert(messages, L["DISPEL"]..": "..table.concat(names, ","))
    end
    -- }}}
    -- {{{ Rest
    local decurse = HealOrganizerDialogEinteilungOptionenDecurse:GetChecked()
    local heal = HealOrganizerDialogEinteilungOptionenHeal:GetChecked()
    local action = L["FFA"] -- default ffa
    if decurse or heal then
        -- decursen und/oder heilen
        if decurse and heal then
            action = L["HEAL"]..", "..L["DECURSE"]
        elseif decurse then
            action = L["DECURSE"]
        elseif heal then
            action = L["HEAL"]
        end
    end
    table.insert(messages, L["REMAINS"]..": "..action)
    -- }}}
    return messages
end -- }}}

function HealOrganizer:ChangeChan() -- {{{
    self:Debug("speicher channel")
    self.db.char.chan = HealOrganizerDialogBroadcastChannelEditbox:GetText()
end -- }}}

function HealOrganizer:HealerOnClick(a) -- {{{
    self:Debug("Healer OnClick")
    self:Debug(a)
end -- }}}

function HealOrganizer:HealerOnDragStart() -- {{{
    self:Debug("Healer OnDragStart")
    local cursorX, cursorY = GetCursorPosition()
    this:ClearAllPoints();
    this:SetPoint("CENTER", nil, "BOTTOMLEFT", cursorX*GetScreenWidthScale(), cursorY*GetScreenHeightScale());
    this:StartMoving()
end -- }}}

function HealOrganizer:HealerOnDragStop() -- {{{
    self:Debug("Healer OnDragStop")
    this:StopMovingOrSizing()
    -- gucken wo ich bin?
    local pools = {
        "HealOrganizerDialogEinteilungHealerpool",
        "HealOrganizerDialogEinteilungHealGroupMainTarget1",
        "HealOrganizerDialogEinteilungHealGroupMainTarget2",
        "HealOrganizerDialogEinteilungHealGroupMainTarget3",
        "HealOrganizerDialogEinteilungHealGroupMainTarget4",
        "HealOrganizerDialogEinteilungHealGroupMainTarget5",
        "HealOrganizerDialogEinteilungHealGroupDispell",
    }
    for _, pool in pairs(pools) do
        poolframe = getglobal(pool)
        if MouseIsOver(poolframe) then
            self:Debug("Bin ber "..poolframe:GetName())
            self:Debug("ich habe "..this:GetName())
            self:Debug("vorher "..healer[this.raidID])
            -- den heiler da zuordnen
            if "HealOrganizerDialogEinteilungHealerpool" == pool then
                healer[this.raidID] = "Rest"
            elseif "HealOrganizerDialogEinteilungHealGroupDispell" == pool then
                healer[this.raidID] = "Dispellen"
            else
                -- MT gruppen
                for i=1,5 do
                    if "HealOrganizerDialogEinteilungHealGroupMainTarget"..i == pool then
                        healer[this.raidID] = "MT"..i
                    end
                end
            end
            self:Debug("nachher "..healer[this.raidID])
            break
        end
    end
    -- positionen aktuallisieren
    self:UpdateDialogValues()
end -- }}}

function HealOrganizer:HealerOnLoad() -- {{{
    self:Debug("OnLoad")
    -- 0 = pool, MT1-M5
    -- 1 = slots
    -- 2 = passt ;)
    this:SetFrameLevel(this:GetFrameLevel() + 2)
    this:RegisterForDrag("LeftButton")
end -- }}}
